            Device = 16F877
            XTAL = 20
    
            REMARKS    OFF  
            Declare BOOTLOADER=OFF
        
            Declare LCD_DTPIN    PORTB.4    
            Declare    LCD_RSPIN    PORTB.3
            Declare    LCD_ENPIN    PORTB.2
            Declare    LCD_INTERFACE    4
            Declare    LCD_LINES    2 
    
            Declare KEYPAD_PORT PORTC'USING KEYPAD ON PORTC           
               
            Declare ADIN_RES 10       ' 10-bit result required 
            Declare ADIN_TAD FRC      ' RC OSC chosen 
            Declare ADIN_STIME 50     ' Allow 50us sample time 
            Dim VAR1 As Word 
            TRISA = %00001111         ' Configure AN0 (PORTA.0-3) as an input 
            ADCON1 = %10000000        ' Set analogue input on PORTA.0 
             
            SERIAL_BAUD = 2400    
            RSOUT_PIN = PORTD.1        'CABLE CROSSED OVER WAS 0
            RSOUT_MODE = INVERTED 'WAS TRUE
            RSOUT_PACE = 1
            'RSIN_PIN = PORTD.1
            'RSIN_MODE = INVERTED  'WAS TRUE
            
            Dim KEYVAL As Byte
            KEYVAL=0 
            Dim KEYNUM As Byte
            KEYNUM=0
            
            Dim TRUE As Byte
            TRUE = 1
            Dim FALSE As Byte
            FALSE = 0
            
            Dim RAW1 As Word
            Dim RAW2 As Word
            Dim RAW3 As Word
            Dim RAW4 As Word
            
            Dim RAWPANR As Word
            Dim RAWPANL As Word
            Dim RAWTILTU As Word
            Dim RAWTILTD As Word
            Dim RAWTELE As Word
            Dim RAWWIDE As Word
            
            Dim PRESCALE As Float
            PRESCALE=0
            
            Dim PAN_LEFT As Word
            PAN_LEFT=0
            Dim PAN_RIGHT As Word
            PAN_RIGHT=0
            Dim TILT_UP As Word
            TILT_UP=0
            Dim TILT_DOWN As Word
            TILT_DOWN=0
            Dim TELE As Word
            TELE=0
            Dim WIDE As Word
            WIDE=0
            
            'PELCO D COMMANDS
            Dim SYNC As Byte
            SYNC=255
            Dim CAM_ID As Byte
            CAM_ID=1
            Dim COMMAND1 As Byte
            COMMAND1=0
            Dim COMMAND2 As Byte
            COMMAND2=0
            Dim PTZDATA1 As Byte
            PTZDATA1=0
            Dim PTZDATA2 As Byte
            PTZDATA2=0
            Dim CHECKSUM As Byte
            CHECKSUM=0
            '------------------------
            
            Dim  RAW_MAX As Word         'POT RAW MAX
            Dim  RAW_MIN As Word         'POT RAW MIN
            Dim  DEADZONE As Word        'POT RAW DEADZONE
            RAW_MAX = 1023
            RAW_MIN = 512 
            DEADZONE = 100
            
            Dim AXISRANGE As Word
            AXISRANGE=(RAW_MAX - RAW_MIN)
            
            Dim BITTEST As Byte
            BITTEST=0
            
            Cls
            DelayMS 5000
            
            PRESCALE = AXISRANGE / (DEADZONE + 63)
            
            COMMAND1=0:COMMAND2=25:PTZDATA1=0:PTZDATA2=3:GoSub PTZOUT 'SET ZOOM SPEED = 3
            DelayMS 1000
            COMMAND1=0:COMMAND2=0:PTZDATA1=0:PTZDATA2=0:CHECKSUM=0
            
    main:   RAW3 = ADIn 1:RAWWIDE = RAW3:RAWTELE = RAW3   'ZOOM
            RAW2 = ADIn 3:RAWTILTU = RAW2:RAWTILTD = RAW2 'TILT
            RAW1 = ADIn 2:RAWPANR = RAW1:RAWPANL = RAW1   'PAN
                    
            If RAWPANR > 512 Then 
               RAWPANR = (RAWPANR - RAW_MIN):PAN_RIGHT = (RAWPANR / PRESCALE)
               If PAN_RIGHT > DEADZONE Then
                  PAN_RIGHT = PAN_RIGHT - DEADZONE             
                  SetBit COMMAND2,1:PTZDATA1 = PAN_RIGHT
                  Else
                  ClearBit COMMAND2,1':PTZDATA1 = 0
               EndIf
               Else
               ClearBit COMMAND2,1':PTZDATA1 = 0
            EndIf
            
            If RAWPANL < 512 Then 
               RAWPANL = (1023 - RAWPANL)
               RAWPANL = (RAWPANL - RAW_MIN):PAN_LEFT = (RAWPANL / PRESCALE)
               If PAN_LEFT > DEADZONE Then
                  PAN_LEFT = PAN_LEFT - DEADZONE           
                  SetBit COMMAND2,2:PTZDATA1 = PAN_LEFT
                  Else
                  ClearBit COMMAND2,2':PTZDATA1 = 0
               EndIf
               Else
               ClearBit COMMAND2,2':PTZDATA1 = 0
            EndIf
            
             
            If RAWTILTU < 512 Then 
               RAWTILTU = (1023 - RAWTILTU)
               RAWTILTU = (RAWTILTU - RAW_MIN):TILT_UP = (RAWTILTU / PRESCALE)
               If TILT_UP > DEADZONE Then
                  TILT_UP = TILT_UP - DEADZONE
                  SetBit COMMAND2,3:PTZDATA2 = TILT_UP 
                  Else
                  ClearBit COMMAND2,3':PTZDATA2 = 0            
               EndIf
               Else
               ClearBit COMMAND2,3':PTZDATA2 = 0
            EndIf
            
            If RAWTILTD > 512 Then 
               RAWTILTD = (RAWTILTD - RAW_MIN):TILT_DOWN = (RAWTILTD / PRESCALE)
               If TILT_DOWN > DEADZONE Then
                  TILT_DOWN = TILT_DOWN - DEADZONE
                  SetBit COMMAND2,4:PTZDATA2 = TILT_DOWN
                  Else
                  ClearBit COMMAND2,4':PTZDATA2 = 0
               EndIf
               Else
               ClearBit COMMAND2,4':PTZDATA2 = 0
            EndIf
            
            If RAWTELE > 512 Then
               RAWTELE = (RAWTELE - RAW_MIN):TELE = (RAWTELE / PRESCALE)
               If TELE > DEADZONE Then
                  TELE = TELE - DEADZONE
                  SetBit COMMAND2,6
                  Else
                  ClearBit COMMAND2,6
               EndIf
               Else
               ClearBit COMMAND2,6
            EndIf
            
            If RAWWIDE < 511 Then 
               RAWWIDE = (1023 - RAWWIDE)
               RAWWIDE = (RAWWIDE - RAW_MIN):WIDE = (RAWWIDE / PRESCALE)
               If WIDE > DEADZONE Then
                  WIDE = WIDE - DEADZONE
                  SetBit COMMAND2,5
                  Else
                  ClearBit COMMAND2,5           
               EndIf
               Else
               ClearBit COMMAND2,5
            EndIf
            
            GoSub PTZOUT
            
            GoTo main
            Return
    
    PTZOUT: CHECKSUM = (CAM_ID + COMMAND1 + COMMAND2 + PTZDATA1 + PTZDATA2) // 256
            RSOut SYNC,CAM_ID,COMMAND1,COMMAND2,PTZDATA1,PTZDATA2,CHECKSUM
            Print At 1,1,@COMMAND2,",",@PTZDATA1,",",@PTZDATA2,",",@CHECKSUM," E"
            Print At 2,12
            Print At 2,1,"TD",@TILT_DOWN," TU",@TILT_UP," BT",@BITTEST," "
            COMMAND1=0:COMMAND2=0:PTZDATA1=0:PTZDATA2=0:CHECKSUM=0
            DelayMS 250
            Return
            
    GETKEY: KEYVAL = 0  
            KEYNUM = LookUpL KEYVAL , [" "] 
            Return   
            
            End
